{
Copyright  1999 by Delphi 5 Developer's Guide - Xavier Pacheco and Steve Teixeira
}

unit UnidadVentanasClases;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ComCtrls, ExtCtrls;

type

  //clase registro que contiene el nombre de la ventana para aadirlo al listbox
  TWindowInfo = class
    WindowName : String; // The window's class name
  end;

  TformVentanasClases = class(TForm)
    Panel1: TPanel;
    btnGetWinInfo: TButton;
    Button1: TButton;
    ListBox1: TListBox;
    procedure btnGetWinInfoClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure hdWinInfoSectionResize(HeaderControl: THeaderControl;
      Section: THeaderSection);
    procedure Button1Click(Sender: TObject);
    procedure lbWinInfoDblClick(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  end;

var
  formVentanasClases: TformVentanasClases;

implementation

uses UnidadMenuPrincipal;


{$R *.DFM}
function EnumWindowsProc(Hw: HWnd; AMainForm: TformVentanasClases): Boolean; stdcall; 
{ This procedure is called by the User32.DLL library as it enumerates
  through windows active in the system. }
var
  WinName, CName: array[0..144] of char;
  WindowInfo: TWindowInfo;
begin
  { Return true by default which indicates not to stop enumerating
    through the windows }
  Result := True;
  GetWindowText(Hw, WinName, 144); // Obtain the current window text
  GetClassName(Hw, CName, 144);    // Obtain the class name of the window
  { Create a TWindowInfo instance and set its fields with the values of
    the window name and window class name. Then add this object to
    ListBox1's Objects array. These values will be displayed later by
    the listbox }
  WindowInfo := TWindowInfo.Create;
  with WindowInfo do
  begin
    SetLength(WindowName, strlen(WinName));
    WindowName := StrPas(WinName);
  end;
  formVentanasClases.ListBox1.Items.AddObject('', WindowInfo); // Add to Objects array
end;

procedure TformVentanasClases.btnGetWinInfoClick(Sender: TObject);
begin
  { Enumerate through all top-level windows being displayed. Pass in the
    call back function EnumWindowsProc which will be called for each
    window }
  EnumWindows(@EnumWindowsProc, 0);
end;

procedure TformVentanasClases.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  { Free all instances of TWindowInfo }
  for i := 0 to ListBox1.Items.Count - 1 do
    TWindowInfo(ListBox1.Items.Objects[i]).Free
end;

procedure TformVentanasClases.hdWinInfoSectionResize(HeaderControl:
   THeaderControl; Section: THeaderSection);
begin
  ListBox1.Invalidate; // Force ListBox1 to redraw itself.
end;

procedure TformVentanasClases.Button1Click(Sender: TObject);
begin
 close;
end;

procedure TformVentanasClases.lbWinInfoDblClick(Sender: TObject);
begin
  formMenuPrincipal.lVentanas.Items.Add (ListBox1.Items[ListBox1.itemindex]);
  close;
end;

procedure TformVentanasClases.ListBox1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with TWindowInfo(ListBox1.Items.Objects[Index]) do
  begin
    ListBox1.Items.Add(WindowName);
    //Rect.Left := Rect.Left + hdWinInfo.Sections[0].Width;
  end;
end;

end.
